package edu.ntua.ivml.qa.algorithm.rapid;

import edu.ntua.ivml.qa.lp.Atom;
import edu.ntua.ivml.qa.lp.Substitution;
import edu.ntua.ivml.qa.lp.Term;
import edu.ntua.ivml.qa.lp.Variable;

public class ProperRenamedAtom {
	private Atom originalAtom;
	private Substitution subst;
	private Atom renamedAtom;
	
	public ProperRenamedAtom(Atom atom) {
		this.originalAtom = atom;
		Term[] terms = atom.getArguments().getTerms();
		
		Term[] tuple = new Term[atom.getPredicate().getArity()];
		subst = new Substitution();
	
		for (int i = 0; i < tuple.length; i++) {
			if (!terms[i].hasUnboundPrefix()) {
				tuple[i] = RapidStatics.dummyVars.get(i);
				subst.add((Variable)tuple[i], terms[i]);
			} else {
				if (i == 0) {
					tuple[i] = Variable.UNBOUND_VARIABLE_1;
				} else {
					tuple[i] = Variable.UNBOUND_VARIABLE_2;
				}
				subst.add((Variable)tuple[i], terms[i]);
			}
		}
		
		renamedAtom = new Atom(atom.getPredicate(), tuple);

	}
	
	public Atom getOriginalAtom() {
		return originalAtom;
	}

	public Atom getRenamedAtom() {
		return renamedAtom;
	}
	
	public Substitution getSubstitution() {
		return subst;
	}
}