package edu.ntua.ivml.qa.algorithm.rapid;

import edu.ntua.ivml.qa.lp.Clause;
import edu.ntua.ivml.qa.lp.ClauseContainer;

public class UnfoldedClause implements ClauseContainer {
	private Clause clause;
	private boolean pure;
	private boolean ok;

	public UnfoldedClause(Clause clause) {
		this.clause = clause;
		this.pure = true;
		this.ok = false;
	}
	
	public UnfoldedClause(Clause clause, boolean pure) {
		this.clause = clause;
		this.pure = pure;
		this.ok = false;
	}
	
	private UnfoldedClause(Clause clause, boolean pure, boolean ok) {
		this.clause = clause;
		this.pure = pure;
		this.ok = ok;
	}
	
	public Clause getClause() {
		return clause;
	}
	
	
	public ClauseContainer removeRedundantAtoms() {
		if (ok) {
			return this;
		}
		
		return new UnfoldedClause(clause.condense().prefixUnboundVariablesByUnderscore(), pure, true);
	}

	public <U extends ClauseContainer> boolean isCCSubsumedBy(U u) {
		return clause.isSubsumedBy(u.getClause());
	}
	
	public boolean isPure() {
		return pure;
	}
	
	public int hashCode() {
		return clause.hashCode();
	}
	
	public boolean equals(Object obj) {
		if (obj instanceof UnfoldedClause) {
			return clause.equals(((UnfoldedClause)obj).clause);
		} else {
			return false;
		}
	}
}
