package edu.ntua.ivml.qa.lp;

import java.util.Set;

public abstract class Term implements Cloneable, Comparable<Term> {

	public abstract Set<Variable> getVariables();
	
	public abstract Term apply(Substitution subst);
	
	public abstract boolean isConstant();
	
	public abstract boolean isVariable();
	
	public abstract boolean isFunctionalTerm();
	
	public abstract int depth();
	
	public abstract String toString();

	public abstract boolean hasUnboundVars();
	
	public boolean hasUnboundPrefix() {
		return false;
	}

	public Object clone() {
		try {
			return super.clone();
		} catch (CloneNotSupportedException e) {
			throw new InternalError();
		}
	}
	
	public Term firstDifferenceTerm(Term t) {
		if (this.equals(t)) {
			return null;
		} else {
			return t;
		}
	}	
	
	public abstract String getStringPrefix();
	
	public boolean unboundEquals(Term t) {
		return this.equals(t);
	}	

}
