package edu.ntua.ivml.qa.utils;

import java.io.PrintStream;
import java.text.NumberFormat;
import java.util.ArrayList;

public class Utils {

	private static NumberFormat nf2 = NumberFormat.getInstance();
	private static NumberFormat nf3 = NumberFormat.getInstance();
	
	static {
		nf2.setMinimumIntegerDigits(2);
		nf2.setMaximumIntegerDigits(2);
		nf3.setMinimumIntegerDigits(3);
		nf3.setMaximumIntegerDigits(3);
	}
	
	private static void printObject(PrintStream out, int size, int i, Object s) {
		char[] max = (size + "").toCharArray();
		char[] number = (i + "").toCharArray();
		
		String r = "";
		for (int j = number.length; j < max.length; j++) {
			r += " ";
		}
		
		r += i;
		
		out.println(r + ": " + s);
	}
	
	public static void printObjectArrayList(PrintStream out, String title, ArrayList<?> set) {
		out.println("-------------------------------------------------------------");
		out.println(title);
		out.println("-------------------------------------------------------------");
		int i = 1;
		for (Object c : set) {
			printObject(out, set.size(), i++, c);
		}
		out.println("-------------------------------------------------------------");
		out.println();
	}	
	
	public static boolean subsumesSome(ArrayList<ArrayList<Integer>> list, ArrayList<Integer> set) {
		for (ArrayList<Integer> l : list) {
			if (set.containsAll(l)) {
				return true;
			}
		}
		
		return false;
	}
	
    public static int binarySearch(ArrayList<Integer> a, int key) {
		int low = 0;
		int high = a.size() - 1;
		
		while (low <= high) {
			int mid = (low + high) >>> 1;
			int midVal = a.get(mid);
			
			if (midVal < key) {
				low = mid + 1;
			} else if (midVal > key) {
				high = mid - 1;
			} else {
				return mid;
			}
		}
		
		return -(low + 1);
    }
}
